;*************************************************************************************************
;* Attempt to Create Windows XP styple collapsible panel in assembly language 
;  (similar to the one in the left side of the Windows Explorer with the links and shortcuts).
;* I can conclude this is not the opt way to implement, so i would be happy,
;  if someone would suggest me better way to work around.    
;* contact: debzequke@gmail.com
;*************************************************************************************************
			.586
			.model flat,stdcall
			option casemap:none

include TaskPanel XP.inc


.code

start:

	inv WinMain
	inv ExitProcess, eax
	
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;\\\ Name 		: WinMain
;\\\ Purpose	: Register window class, create and display the main  window, 
;                 and enter  message loop
;\\\ Inputs		: -
;\\\ Outputs	: Program exit code
;\\\ Note       : -
;-------------------------------------------------------------------------------	
WinMain proc 

	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov hInstance, FUNC(GetModuleHandle, NULL)
;	inv GetCommandLine	
	inv InitCommonControls
	
	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW 
	mov wc.lpfnWndProc, OFFSET MainWndProc
	mov wc.cbClsExtra, NULL
	mov wc.cbWndExtra, NULL
	m2m wc.hInstance, hInstance
	mov wc.hbrBackground, COLOR_WINDOW+1
	mov wc.lpszMenuName, 10000
	mov wc.lpszClassName, OFFSET szmainClass
	
	inv LoadIcon, NULL, IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm, eax
	
	inv LoadCursor, NULL, IDC_ARROW
	mov   wc.hCursor,eax
		
	inv RegisterClassEx, addr wc
	
	mov wc.lpfnWndProc, OFFSET ChildWndProc
	mov wc.hbrBackground, COLOR_BTNFACE+1 
	mov wc.lpszClassName, OFFSET szchildClass
	inv RegisterClassEx, ADDR wc
	
	inv CreateWindowEx, NULL, ADDR szmainClass, ADDR szappName, \
	                    WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, \
	                    700, 440, NULL, NULL, \
           				hInstance, NULL
	mov hwnd, eax
		                      
	inv SetWindowLong, hwnd, GWL_STYLE, 80347136 
	
	inv ShowWindow, hwnd, SW_SHOWNORMAL
	inv UpdateWindow, hwnd
	
	.WHILE TRUE
		inv GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		inv TranslateMessage, ADDR msg
		inv DispatchMessage, ADDR msg
	.ENDW
	
	return msg.wParam
	
WinMain endp

;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;\\\ Name 		: MainWndProc
;\\\ Purpose	: Processes Main application messages 
;\\\ Inputs		: hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;\\\ Outputs	: -
;\\\ Note       : -
;-------------------------------------------------------------------------------
MainWndProc proc hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
		
	SWITCH uMsg
		CASE WM_CREATE			
			mov hwndChild, FUNC(CreateWindowEx, 0, ADDR szchildClass, NULL, WS_CHILD or WS_VISIBLE, 0, 0, 207, 400, hwnd, 0, hInstance, 0)			
			inv SetWindowLong, hwndChild, GWL_STYLE, 1409482752  
			
		CASE WM_COMMAND
			mov eax, wParam
			mov edx, eax
			and eax, 0ffffh
			shr edx, 16
			.if dx==BN_CLICKED
				.if ax==10001
					inv SendMessage, hwnd, WM_CLOSE, 0, 0
				.elseif ax==10101
					mbx hwnd, SADD("TaskPanel XP"), addr szappName, 0
				.endif
			.endif
			
		CASE WM_DESTROY
			inv PostQuitMessage,NULL
			
		DEFAULT
			inv DefWindowProc, hwnd, uMsg, wParam, lParam 		
		    ret
	ENDSW
		
	return FALSE 
	
MainWndProc endp

;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;\\\ Name 		: ChildWndProc
;\\\ Purpose	: Processes Child window application messages 
;\\\ Inputs		: hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;\\\ Outputs	: -
;\\\ Note       : -
;-------------------------------------------------------------------------------
ChildWndProc proc hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	LOCAL wc:WNDCLASSEX
	LOCAL ps:PAINTSTRUCT
	LOCAL hdc:HDC
	LOCAL hmemDc:HDC
	LOCAL rect:RECT
	
	SWITCH uMsg
		CASE WM_CREATE			
			mov wc.cbSize, sizeof WNDCLASSEX
			inv GetClassInfoEx, hInstance, SADD("STATIC"), addr wc
			m2m dwoldStaticProc, wc.lpfnWndProc
			mov wc.lpfnWndProc, OFFSET StaticWndProc
			m2m wc.hInstance, hInstance
			mov wc.lpszClassName, OFFSET szstaticClass
			inv RegisterClassEx, ADDR wc
				
			mov hwndSt1, FUNC(CreateWindowEx, 0, ADDR szstaticClass, 0, SS_BITMAP or WS_VISIBLE OR WS_CHILD, 9, 11, 186, 25, hwnd, 0, hInstance, 0)
			mov hwndSt2, FUNC(CreateWindowEx, 0, SADD("STATIC"), 0, SS_BITMAP or WS_VISIBLE OR WS_CHILD, 9, 36, 187, 137, hwnd, 0, hInstance, 0)
			mov hwndSt3, FUNC(CreateWindowEx, 0, ADDR szstaticClass, 0, SS_BITMAP or WS_VISIBLE OR WS_CHILD, 9, 185, 187, 25, hwnd, 0, hInstance, 0)
			mov hwndSt4, FUNC(CreateWindowEx, 0, SADD("STATIC"), 0, SS_BITMAP or WS_VISIBLE OR WS_CHILD, 10, 210, 187, 137, hwnd, 0, hInstance, 0)
			
			mov hbitmapBk, FUNC(LoadBitmap, hInstance, 2)
			mov hbitmap1a, FUNC(LoadBitmap, hInstance, 3)
			mov hbitmap1b, FUNC(LoadBitmap, hInstance, 4)
			mov hbitmap1c, FUNC(LoadBitmap, hInstance, 5)
			mov hbitmap1d, FUNC(LoadBitmap, hInstance, 6)
			mov hbitmap2,  FUNC(LoadBitmap, hInstance, 7)
			mov hbitmap3a, FUNC(LoadBitmap, hInstance, 8)
			mov hbitmap3b, FUNC(LoadBitmap, hInstance, 9)
			mov hbitmap3c, FUNC(LoadBitmap, hInstance, 10)
			mov hbitmap3d, FUNC(LoadBitmap, hInstance, 11)
			mov hbitmap4 , FUNC(LoadBitmap, hInstance, 12)
						
			inv SendMessage, hwndSt2, STM_SETIMAGE, IMAGE_BITMAP, hbitmap2
			inv SendMessage, hwndSt4, STM_SETIMAGE, IMAGE_BITMAP, hbitmap4

    	CASE WM_CTLCOLORSTATIC    		
    		inv SetBkMode, wParam, TRANSPARENT
			inv GetStockObject, BLACK_BRUSH			
			ret
		

		CASE WM_PAINT
			mov hdc, FUNC(BeginPaint, hwnd, ADDR ps)			
			mov hmemDc, FUNC(CreateCompatibleDC, hdc)
			inv SelectObject, hmemDc, hbitmapBk
			inv GetClientRect, hwnd, ADDR rect
			inv BitBlt, hdc, 0, 0, rect.right, rect.bottom, hmemDc, 0, 0, SRCCOPY
			inv DeleteObject, hmemDc
				
		CASE WM_DESTROY
			inv DeleteObject, hbitmapBk
			inv DeleteObject, hbitmap1a
			inv DeleteObject, hbitmap1b
			inv DeleteObject, hbitmap1c
			inv DeleteObject, hbitmap1d
			inv DeleteObject, hbitmap2
			inv DeleteObject, hbitmap3a
			inv DeleteObject, hbitmap3b
			inv DeleteObject, hbitmap3c
			inv DeleteObject, hbitmap3d
			inv PostQuitMessage,NULL
			
		DEFAULT
			invoke DefWindowProc, hwnd, uMsg, wParam, lParam 		
		    ret
	ENDSW
		
	return FALSE 
	
ChildWndProc endp

;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
;\\\ Name 		: StaticWndProc
;\\\ Purpose	: Processes superclassed static window messages 
;\\\ Inputs		: hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;\\\ Outputs	: -
;\\\ Note       : -
;-------------------------------------------------------------------------------
StaticWndProc proc uses ebx hwnd:DWORD, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	LOCAL pt:POINT
	LOCAL rect:RECT
	LOCAL ps:PAINTSTRUCT
	LOCAL hdc:HDC
	LOCAL hmemDc:HDC
	
    SWITCH uMsg
    	CASE WM_CTLCOLORSTATIC    		
    		inv SetBkMode, wParam, TRANSPARENT
			inv GetStockObject, BLACK_BRUSH			
			ret
		
		CASE WM_PAINT
			mov hdc, FUNC(BeginPaint, hwnd, ADDR ps)
			mov hmemDc, FUNC(CreateCompatibleDC, hdc)			
			inv GetClientRect, hwnd, ADDR rect
			mov eax, hwnd
			.if eax==hwndSt1
				inv IsWindowVisible, hwndSt2
				.if eax
					.if !fhover1
						inv SelectObject, hmemDc, hbitmap1a				
						inv BitBlt, hdc, 0, 0, rect.right, rect.bottom, hmemDc, 0, 0, SRCCOPY
					.else
						inv SelectObject, hmemDc, hbitmap1b
						inv BitBlt, hdc, 0, 0, rect.right, rect.bottom, hmemDc, 0, 0, SRCCOPY
					.endif				
				.else
					.if !fhover1
						inv SelectObject, hmemDc, hbitmap1c				
						inv BitBlt, hdc, 0, 0, rect.right, rect.bottom, hmemDc, 0, 0, SRCCOPY
					.else
						inv SelectObject, hmemDc, hbitmap1d
						inv BitBlt, hdc, 0, 0, rect.right, rect.bottom, hmemDc, 0, 0, SRCCOPY
					.endif
				.endif			
			.elseif eax==hwndSt3
				inv IsWindowVisible, hwndSt4
				.if eax
					.if !fhover2
						inv SelectObject, hmemDc, hbitmap3a				
						inv BitBlt, hdc, 0, 0, rect.right, rect.bottom, hmemDc, 0, 0, SRCCOPY
					.else
						inv SelectObject, hmemDc, hbitmap3b
						inv BitBlt, hdc, 0, 0, rect.right, rect.bottom, hmemDc, 0, 0, SRCCOPY
					.endif				
				.else
					.if !fhover2
						inv SelectObject, hmemDc, hbitmap3c				
						inv BitBlt, hdc, 0, 0, rect.right, rect.bottom, hmemDc, 0, 0, SRCCOPY
					.else
						inv SelectObject, hmemDc, hbitmap3d
						inv BitBlt, hdc, 0, 0, rect.right, rect.bottom, hmemDc, 0, 0, SRCCOPY
					.endif
				.endif
			.endif		
			
			inv DeleteObject, hmemDc
			
			return 0

    	CASE WM_MOUSEMOVE
    		mov ebx, FUNC(GetParent, hwnd)
			mov ebx, FUNC(GetParent, ebx)	
			mov eax, hwnd
			.if eax==hwndSt1		
				inv GetActiveWindow			
				.if eax==ebx			
					inv GetCursorPos, ADDR pt
					inv GetWindowRect, hwnd, ADDR rect
					inv PtInRect, ADDR rect, pt.x, pt.y
					.if eax
						inv GetCapture
						.if !eax
							inv SetCapture, hwnd
							mov fhover1, TRUE
							inv InvalidateRect, hwnd, FALSE, FALSE
							inv SetCursor,  FUNC(LoadCursor, hInstance, 25)											
						.endif
					.else
						inv GetCapture
						.if eax
							inv ReleaseCapture
							mov fhover1, FALSE 
							inv InvalidateRect, hwnd, FALSE, FALSE						
						.endif
					.endif
				.endif
			.elseif eax==hwndSt3
				inv GetActiveWindow			
				.if eax==ebx			
					inv GetCursorPos, ADDR pt
					inv GetWindowRect, hwnd, ADDR rect
					inv PtInRect, ADDR rect, pt.x, pt.y
					.if eax
						inv GetCapture
						.if !eax
							inv SetCapture, hwnd
							mov fhover2, TRUE
							inv InvalidateRect, hwnd, FALSE, FALSE
							inv SetCursor,  FUNC(LoadCursor, hInstance, 25)											
						.endif
					.else
						inv GetCapture
						.if eax
							inv ReleaseCapture
							mov fhover2, FALSE 
							inv InvalidateRect, hwnd, FALSE, FALSE						
						.endif
					.endif
				.endif
			.endif
			
    	CASE WM_LBUTTONDOWN   
    		mov eax, hwnd
    		.if eax==hwndSt1 		
	    		inv IsWindowVisible, hwndSt2
	    		.if eax
	    			inv AnimateWindow, hwndSt2, 200, AW_HIDE or AW_VER_NEGATIVE or AW_SLIDE	    		
	    			inv SetWindowPos, hwndSt3, hwnd, 9, 45, 0, 0, SWP_NOSIZE or SWP_SHOWWINDOW
	    			inv SetWindowPos, hwndSt4, hwnd, 10, 70, 0, 0, SWP_NOSIZE     		   
	    		.else
	    			inv AnimateWindow, hwndSt2, 200, AW_ACTIVATE or AW_VER_POSITIVE or AW_SLIDE
	    			inv SetWindowPos, hwndSt3, hwnd, 9, 185, 0, 0, SWP_NOSIZE or SWP_SHOWWINDOW
	    			inv SetWindowPos, hwndSt4, hwnd, 10, 210, 0, 0, SWP_NOSIZE    		 
	    		.endif
	    	.elseif eax==hwndSt3
	    		inv IsWindowVisible, hwndSt4
				.if eax
	    			inv AnimateWindow, hwndSt4, 200, AW_HIDE or AW_VER_NEGATIVE or AW_SLIDE	    			    		 
	    		.else
	    			inv AnimateWindow, hwndSt4, 200, AW_ACTIVATE or AW_VER_POSITIVE or AW_SLIDE	    			
	    		.endif	    		
	    	.endif
	    	
    		inv InvalidateRect, hwndChild, FALSE, FALSE
    	
    	CASE WM_NCHITTEST
    		return TRUE
    		  
    ENDSW

	inv CallWindowProc, dwoldStaticProc, hwnd, uMsg, wParam, lParam
    ret
    
StaticWndProc endp


end start
